/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of LibMaxsi.

	LibMaxsi is free software: you can redistribute it and/or modify it under
	the terms of the GNU Lesser General Public License as published by the Free
	Software Foundation, either version 3 of the License, or (at your option)
	any later version.

	LibMaxsi is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
	more details.

	You should have received a copy of the GNU Lesser General Public License
	along with LibMaxsi. If not, see <http://www.gnu.org/licenses/>.

	types.h
	Declares the required datatypes for the x86 architecture.

******************************************************************************/

// Declare all basic datatypes.
#if !defined(LIBMAXSI_SHARED_TYPES_DEFINED)
	#define  LIBMAXSI_SHARED_TYPES_DEFINED

	// We put all basic datatypes in sortix/types.h
	#ifdef SORTIX
		#include <sortix/bits.h>
	#endif

#endif

// Declare everything that POSIX and others need.
#if defined(LIBMAXSI_NEED_C_TYPES) && !defined(LIBMAXSI_C_TYPES_DEFINED) 
	#define LIBMAXSI_C_TYPES_DEFINED

	typedef unsigned useconds_t;

	typedef uintmax_t off_t;

	struct tm
	{
		int tm_sec;		// Seconds [0,60]. 
		int tm_min;		// Minutes [0,59]. 
		int tm_hour;	// Hour [0,23]. 
		int tm_mday;	// Day of month [1,31]. 
		int tm_mon;		// Month of year [0,11]. 
		int tm_year;	// Years since 1900. 
		int tm_wday;	// Day of week [0,6] (Sunday =0). 
		int tm_yday;	// Day of year [0,365]. 
		int tm_isdst;	// Daylight Savings flag.
	};

	typedef unsigned mode_t;

#endif

// Declare all the LibMaxsi extensions.
#if !defined(LIBMAXSI_NEED_C_TYPES) && !defined(LIBMAXSI_TYPES_H)
	#define LIBMAXSI_TYPES_H

	// A byte is naturally 8 bits. Seriously.
	typedef uint8_t byte;
	typedef unsigned int nat;

	#define BYTE_MAX UINT8_MAX
	#define BITS(type) (8*sizeof(type))

#endif

#ifdef LIBMAXSI_NEED_C_TYPES
#undef LIBMAXSI_NEED_C_TYPES
#endif

