/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of LibMaxsi.

	LibMaxsi is free software: you can redistribute it and/or modify it under
	the terms of the GNU Lesser General Public License as published by the Free
	Software Foundation, either version 3 of the License, or (at your option)
	any later version.

	LibMaxsi is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
	more details.

	You should have received a copy of the GNU Lesser General Public License
	along with LibMaxsi. If not, see <http://www.gnu.org/licenses/>.

	unistd.h
	The <unistd.h> header defines miscellaneous symbolic constants and types,
	and declares miscellaneous functions.

******************************************************************************/

// TODO: Make this header comply with POSIX-1.2008

#ifndef	_UNISTD_H
#define	_UNISTD_H 1

#include <features.h>
#define LIBMAXSI_NEED_C_TYPES
#include <libmaxsi/types.h>
#include <stdio.h>

// TODO: uid_t, gid_t, off_t, pid_t

__BEGIN_DECLS

// Currently just say we support the newest POSIX.
// TODO: Support the newest POSIX.
#define _POSIX_VERSION 200809L
#define _POSIX2_VERSION	200809L

// Currently just say we support the newest X/Open
// TODO: Support the newest X/Open
#define _XOPEN_VERSION 700

// TODO: We need a LOT of defines here.


// TODO: We need to declare some more functions here.
int close(int fildes);
int fsync(int fsync);
int ftruncate(int fildes, off_t length);
int usleep(useconds_t useconds);
off_t lseek(int fildes, off_t offset, int whence);
ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
ssize_t read(int fildes, void *buf, size_t nbyte);
ssize_t write(int fildes, const void *buf, size_t nbyte);
unsigned sleep(unsigned seconds);

__END_DECLS

#endif

